commit 189b51fab6457fde08f788897b75baa22a89b3b9
Author: Iustin Pop <iustin@google.com>
Date:   Wed Aug 29 16:10:41 2012 +0200

    Move generated htools test stubs to htest/
    
    This moves the last (I think) htools-related bits out of test/ under
    htest/.
    
    Signed-off-by: Iustin Pop <iustin@google.com>
    Reviewed-by: René Nussbaumer <rn@google.com>

diff --git a/htest/shelltests/htools-hail.test b/htest/shelltests/htools-hail.test
index a0bddf1..2f1c9f9 100644
--- a/htest/shelltests/htools-hail.test
+++ b/htest/shelltests/htools-hail.test
@@ -1,77 +1,77 @@
 # test that on invalid files it can't parse the request
-./test/hail /dev/null
+./htest/hail /dev/null
 >>>2 /Invalid JSON/
 >>>= !0
 
 # another invalid example
-echo '[]' | ./test/hail -
+echo '[]' | ./htest/hail -
 >>>2 /Unable to read JSObject/
 >>>= !0
 
 # empty dict
-echo '{}' | ./test/hail -
+echo '{}' | ./htest/hail -
 >>>2 /key 'request' not found/
 >>>= !0
 
-echo '{"request": 0}' | ./test/hail -
+echo '{"request": 0}' | ./htest/hail -
 >>>2 /key 'request'/
 >>>= !0
 
-./test/hail $TESTDATA_DIR/hail-invalid-reloc.json
+./htest/hail $TESTDATA_DIR/hail-invalid-reloc.json
 >>>2 /key 'name': Unable to read String/
 >>>= !0
 
 # and now start the real tests
-./test/hail $TESTDATA_DIR/hail-alloc-drbd.json
+./htest/hail $TESTDATA_DIR/hail-alloc-drbd.json
 >>> /"success":true,.*,"result":\["node2","node1"\]/
 >>>= 0
 
-./test/hail $TESTDATA_DIR/hail-reloc-drbd.json
+./htest/hail $TESTDATA_DIR/hail-reloc-drbd.json
 >>> /"success":true,.*,"result":\["node1"\]/
 >>>= 0
 
-./test/hail $TESTDATA_DIR/hail-node-evac.json
+./htest/hail $TESTDATA_DIR/hail-node-evac.json
 >>> /"success":true,"info":"Request successful: 0 instances failed to move and 1 were moved successfully"/
 >>>= 0
 
-./test/hail $TESTDATA_DIR/hail-change-group.json
+./htest/hail $TESTDATA_DIR/hail-change-group.json
 >>> /"success":true,"info":"Request successful: 0 instances failed to move and 1 were moved successfully"/
 >>>= 0
 
 # check that hail can use the simu backend
-./test/hail --simu p,8,8T,16g,16 $TESTDATA_DIR/hail-alloc-drbd.json
+./htest/hail --simu p,8,8T,16g,16 $TESTDATA_DIR/hail-alloc-drbd.json
 >>> /"success":true,/
 >>>= 0
 
 # check that hail can use the text backend
-./test/hail -t $T/simu-rebal-merged.standard $TESTDATA_DIR/hail-alloc-drbd.json
+./htest/hail -t $T/simu-rebal-merged.standard $TESTDATA_DIR/hail-alloc-drbd.json
 >>> /"success":true,/
 >>>= 0
 
 # check that hail can use the simu backend
-./test/hail -t $T/simu-rebal-merged.standard $TESTDATA_DIR/hail-alloc-drbd.json
+./htest/hail -t $T/simu-rebal-merged.standard $TESTDATA_DIR/hail-alloc-drbd.json
 >>> /"success":true,/
 >>>= 0
 
 # check that hail pre/post saved state differs after allocation
-./test/hail -v -v -v -p $TESTDATA_DIR/hail-alloc-drbd.json -S $T/hail-alloc >/dev/null 2>&1 && ! diff -q $T/hail-alloc.pre-ialloc $T/hail-alloc.post-ialloc
+./htest/hail -v -v -v -p $TESTDATA_DIR/hail-alloc-drbd.json -S $T/hail-alloc >/dev/null 2>&1 && ! diff -q $T/hail-alloc.pre-ialloc $T/hail-alloc.post-ialloc
 >>> /Files .* and .* differ/
 >>>= 0
 
 # check that hail pre/post saved state differs after relocation
-./test/hail -v -v -v -p $TESTDATA_DIR/hail-reloc-drbd.json -S $T/hail-reloc >/dev/null 2>&1 && ! diff -q $T/hail-reloc.pre-ialloc $T/hail-reloc.post-ialloc
+./htest/hail -v -v -v -p $TESTDATA_DIR/hail-reloc-drbd.json -S $T/hail-reloc >/dev/null 2>&1 && ! diff -q $T/hail-reloc.pre-ialloc $T/hail-reloc.post-ialloc
 >>> /Files .* and .* differ/
 >>>= 0
 
 # evac tests
-./test/hail $T/hail-node-evac.json.primary-only
+./htest/hail $T/hail-node-evac.json.primary-only
 >>> /"success":true,"info":"Request successful: 0 instances failed to move and 1 were moved successfully"/
 >>>= 0
 
-./test/hail $T/hail-node-evac.json.secondary-only
+./htest/hail $T/hail-node-evac.json.secondary-only
 >>> /"success":true,"info":"Request successful: 0 instances failed to move and 1 were moved successfully"/
 >>>= 0
 
-./test/hail $T/hail-node-evac.json.all
+./htest/hail $T/hail-node-evac.json.all
 >>> /"success":true,"info":"Request successful: 0 instances failed to move and 1 were moved successfully"/
 >>>= 0