commit aa197ee4e10c5b32da72afc67688cbdbf851bc0e
Author: Vangelis Koukis <vkoukis@cslab.ece.ntua.gr>
Date:   Tue May 10 13:35:22 2011 +0300

    Fix redundant whitespace at end of lines
    
    Remove all unecessary whitespace at end of lines.
    See
    http://stackoverflow.com/questions/5257553/coloring-white-space-in-git-diffs-output
    
    for a way to have git highlight redundant whitespace automatically.

diff --git a/api/fixtures/api_test_data.json b/api/fixtures/api_test_data.json
index d7468c0..f21a310 100644
--- a/api/fixtures/api_test_data.json
+++ b/api/fixtures/api_test_data.json
@@ -5,7 +5,7 @@
         "fields": {
             "cpu": 1,
             "ram": 1024,
-            "disk": 20 
+            "disk": 20
         }
     },
     {
@@ -14,7 +14,7 @@
         "fields": {
             "cpu": 1,
             "ram": 1024,
-            "disk": 40 
+            "disk": 40
         }
     },
     {
@@ -23,7 +23,7 @@
         "fields": {
             "cpu": 1,
             "ram": 1024,
-            "disk": 80 
+            "disk": 80
         }
     },
     {
@@ -32,7 +32,7 @@
         "fields": {
             "cpu": 1,
             "ram": 2048,
-            "disk": 20 
+            "disk": 20
         }
     },
     {
@@ -41,7 +41,7 @@
         "fields": {
             "cpu": 1,
             "ram": 2048,
-            "disk": 40 
+            "disk": 40
         }
     },
     {
@@ -50,7 +50,7 @@
         "fields": {
             "cpu": 1,
             "ram": 2048,
-            "disk": 80 
+            "disk": 80
         }
     },
     {
@@ -59,7 +59,7 @@
         "fields": {
             "cpu": 1,
             "ram": 4096,
-            "disk": 20 
+            "disk": 20
         }
     },
     {
@@ -68,7 +68,7 @@
         "fields": {
             "cpu": 1,
             "ram": 4096,
-            "disk": 40 
+            "disk": 40
         }
     },
     {
@@ -77,7 +77,7 @@
         "fields": {
             "cpu": 1,
             "ram": 4096,
-            "disk": 80 
+            "disk": 80
         }
     },
     {
@@ -86,7 +86,7 @@
         "fields": {
             "cpu": 2,
             "ram": 1024,
-            "disk": 20 
+            "disk": 20
         }
     },
     {
@@ -95,7 +95,7 @@
         "fields": {
             "cpu": 2,
             "ram": 1024,
-            "disk": 40 
+            "disk": 40
         }
     },
     {
@@ -104,7 +104,7 @@
         "fields": {
             "cpu": 2,
             "ram": 1024,
-            "disk": 80 
+            "disk": 80
         }
     },
     {
@@ -113,7 +113,7 @@
         "fields": {
             "cpu": 2,
             "ram": 2048,
-            "disk": 20 
+            "disk": 20
         }
     },
     {
@@ -122,7 +122,7 @@
         "fields": {
             "cpu": 2,
             "ram": 2048,
-            "disk": 40 
+            "disk": 40
         }
     },
     {
@@ -131,7 +131,7 @@
         "fields": {
             "cpu": 2,
             "ram": 2048,
-            "disk": 80 
+            "disk": 80
         }
     },
     {
@@ -140,7 +140,7 @@
         "fields": {
             "cpu": 2,
             "ram": 4096,
-            "disk": 20 
+            "disk": 20
         }
     },
     {
@@ -149,7 +149,7 @@
         "fields": {
             "cpu": 2,
             "ram": 4096,
-            "disk": 40 
+            "disk": 40
         }
     },
     {
@@ -158,7 +158,7 @@
         "fields": {
             "cpu": 2,
             "ram": 4096,
-            "disk": 80 
+            "disk": 80
         }
     },
     {
@@ -167,7 +167,7 @@
         "fields": {
             "cpu": 4,
             "ram": 1024,
-            "disk": 20 
+            "disk": 20
         }
     },
     {
@@ -176,7 +176,7 @@
         "fields": {
             "cpu": 4,
             "ram": 1024,
-            "disk": 40 
+            "disk": 40
         }
     },
     {
@@ -185,7 +185,7 @@
         "fields": {
             "cpu": 4,
             "ram": 1024,
-            "disk": 80 
+            "disk": 80
         }
     },
     {
@@ -194,7 +194,7 @@
         "fields": {
             "cpu": 4,
             "ram": 2048,
-            "disk": 20 
+            "disk": 20
         }
     },
     {
@@ -203,7 +203,7 @@
         "fields": {
             "cpu": 4,
             "ram": 2048,
-            "disk": 40 
+            "disk": 40
         }
     },
     {
@@ -212,7 +212,7 @@
         "fields": {
             "cpu": 4,
             "ram": 2048,
-            "disk": 80 
+            "disk": 80
         }
     },
     {
@@ -221,7 +221,7 @@
         "fields": {
             "cpu": 4,
             "ram": 4096,
-            "disk": 20 
+            "disk": 20
         }
     },
     {
@@ -230,7 +230,7 @@
         "fields": {
             "cpu": 4,
             "ram": 4096,
-            "disk": 40 
+            "disk": 40
         }
     },
     {
@@ -239,7 +239,7 @@
         "fields": {
             "cpu": 4,
             "ram": 4096,
-            "disk": 80 
+            "disk": 80
         }
     },
     {
@@ -333,4 +333,4 @@
             "sourcevm": 1001
         }
     }
-] 
+]